﻿using System;
using System.Drawing;
using Wisej.Web;

namespace Wisej1
{
    public class LoginDesktop : Desktop
    {
        private readonly TextBox loginTextBox = new TextBox();
        private readonly TextBox passTextBox = new TextBox();
        private readonly Button loginButton = new Button();
        private readonly Panel loginFormPanel = new Panel();


        public LoginDesktop()
        {
            var pad = 6;

            this.Size = new Size(240, 120);

            Int32 top = 0;

            top += 6;
            loginTextBox.Anchor = AnchorStyles.Left | AnchorStyles.Top | AnchorStyles.Right;
            loginTextBox.Location = new Point(pad, top);
            loginTextBox.SpellCheck = false;
            loginTextBox.TabIndex = 1;
            loginTextBox.Watermark = "Login";
            loginTextBox.Width = loginFormPanel.Width - pad * 2;
            top += loginTextBox.Height;

            top += 6;
            passTextBox.Anchor = AnchorStyles.Left | AnchorStyles.Top | AnchorStyles.Right;
            passTextBox.Location = new Point(pad, top);
            passTextBox.PasswordChar = '*';
            passTextBox.TabIndex = 2;
            passTextBox.Watermark = "Password";
            passTextBox.Width = loginFormPanel.Width - pad * 2;
            top += passTextBox.Height;

            top += 6;
            loginButton.Anchor = AnchorStyles.Top;
            loginButton.Click += LoginButton_Click;
            loginButton.Location = new Point(loginFormPanel.Width / 2 - loginButton.Width / 2, top);
            loginButton.TabIndex = 3;
            loginButton.Text = "Log in";
            top += loginButton.Height;

            top += 6;
            loginFormPanel.Anchor = AnchorStyles.None;
            loginFormPanel.Controls.Add(loginTextBox);
            loginFormPanel.Controls.Add(passTextBox);
            loginFormPanel.Controls.Add(loginButton);
            loginFormPanel.BorderStyle = BorderStyle.Solid;
            loginFormPanel.Location = new Point(400, 200);
            loginFormPanel.Size = new Size(320, top);

            this.Controls.Add(loginFormPanel);
        }

        private void LoginButton_Click(Object sender, EventArgs e)
        {
            try
            {
                if (SessionManager.Login(loginTextBox.Text, passTextBox.Text))
                {
                    MessageBox.Show("Login successful.");
                }
                else
                {
                    MessageBox.Show("Login failed.\r\nIncorrect login or password.", "Login error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    loginTextBox.SelectAll();
                    passTextBox.Clear();
                    passTextBox.Focus();
                }
            }
            catch (Exception exception)
            {
                MessageBox.Show(exception.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
