﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Wisej.Web;

namespace Wisej1
{
    public static class SessionManager
    {
        private static Dictionary<String, String> sessions = new Dictionary<String, String>();

        internal static Boolean Login(String login, String password)
        {
            var token = Guid.NewGuid().ToString();
            Application.Cookies.Add("Token", token);
            sessions.Add(token, token);
            return true;
        }

        internal static Boolean IsAuthorized(String token)
        {
            return sessions.ContainsKey(token);
        }

        internal static void Logout()
        {
            var token = Application.Cookies["Token"];
            if (sessions.ContainsKey(token))
                sessions.Remove(token);

            Application.Exit();
        }
    }
}